#! /usr/local/bin/python -O
"Split MIME message into files"


import sys, mimetools, multifile


def error(estr):
   sys.stderr.write("%s\n" % estr)
   sys.exit()


def put_file(_from, _to, encoding):
   outfile = open(_to, 'w')
   if encoding in ('', '7bit', '8bit', 'binary'):
      mimetools.copyliteral(_from, outfile)
   else:
      mimetools.decode(_from, outfile, encoding)
   outfile.close()


if len(sys.argv) <> 2:
   error("Usage: %s filename" % sys.argv[0])
else:
   infile = open(sys.argv[1], 'r')

m = mimetools.Message(infile)
mail_from = m.getaddr("from")

boundary = m.getparam("boundary")
if not boundary:
   if not m.getheader("Content-Type"):
      error("This is not a MIME message")

   else:
      name = m.getparam("name")
      if not name:
         name = "outfile0"
      put_file(infile, name, m.getencoding())

else:
   mf = multifile.MultiFile(infile)
   n = 0 # number of MIME-parts

   mf.push(boundary)
   while 1:
      line = mf.readline()
      if line and n >= 2: # Skip two parts - MIME warning and mail text
         error("CANNOT BE THERE!")

      else:
         if not mf.next():
            break

         n = n + 1
         if n >= 2:
            m = mimetools.Message(mf)
            name = m.getparam("name")
            if not name:
               name = "outfile%d" % n

            put_file(mf, name, m.getencoding())
   mf.pop()
